!= Module ECCM
!
! Authors::   SUGIYAMA Koichiro, ODAKA Masatsugu
! Version::   $Id: eccm.f90,v 1.28 2010-08-11 07:34:19 sugiyama Exp $
! Tag Name::  $Name: arare4-20100910 $
! Copyright:: Copyright (C) GFD Dennou Club, 2006. All rights reserved.
! License::   See COPYRIGHT[link:../../COPYRIGHT]
!
!== Overview 
!
!ǮŪ˾徺뵤βٸΨ׻, ſ尵ʿդ鰵Ϥ
!
!== Error Handling
!
!== Known Bugs
!
!== Note
!
!  * Ǯ, ʿʬ̤
!  * 顼٤­ʤΤ, 󥲥å. 
!
!== Future Plans
!

module ECCM

  !⥸塼ɤ߹

  use gtool_history                   !case Ima 
  use dc_message, only: MessageNotify

  use gridset,  only: DimZMin,       &!  Z β
    &                 DimZMax,       &!  Z ξ 
    &                 RegZMin,       &!
    &                 SpcNum,        &!
    &                 s_Z,           &!
    &                 DelZ            !
  use basicset,only:  MolWtDry,      &!
    &                 MolWtWet,      &!
    &                 CpDryMol,      &!
    &                 SpcWetID,      &!
    &                 TempSfc,       &!
    &                 PressSfc,      &!
    &                 Grav,          &!
    &                 GasRDry,       &!ɲ(ima)
    &                 CpDry           !ɲ(ima)
  use chemcalc, only: SvapPress,        &!
    &                 LatentHeatPerMol, &!
    &                 ReactHeatNH4SHPerMol
  use moistset, only: CondNum,          &!ŷο
    &                 IdxCG,            &!ŷ()ź
    &                 IdxCC,            &!ŷ()ź
    &                 GasNum,           &!Το
    &                 IdxNH3,           &!NH3()ź
    &                 IdxH2S             !H2S()ź
  use ChemData, only: GasRUniv        
  use MoistFunc,only: DelMolFrNH4SH 
  use StoreStab,only: StoreStabTemp, StoreStabMolWt

  !ۤηػ
  implicit none

  !°λ
  private

  !ؿθ
  public ECCM_MolFr
  public ECCM_Stab
  public ECCM_Dry
  public ECCM_Wet
  public ECCM_Wet2
  public ECCM_Ima
  public HUM
  public HUM_Takemi2007
  public HUM_Takemi2007_TDRY
  public HUM_Takemi2007_MDRY
  public ECCM_Takemi2007
  public HUM_Takemi2007ALL
  public Height
contains

!!!------------------------------------------------------------------------------!!!
!  subroutine ECCM_Dry( a_MolFrIni, Humidity, z_Temp, z_Press, z_MolWtMean, za_MolFr )
  subroutine ECCM_Dry( a_MolFrIni, Humidity, z_Temp, z_Press, za_MolFr )
    !
    !== 
    !  * ǮٸΨ˱ä١ϤᡢФƻꤵ줿м٤Ȥʤ褦˶ŷʬΥ
    !  * Ǯϴ絤ΤΤɽ
    !    * ήΤˤǮϴʬΤΤɽƤ뤿
    !  * 絤ʿʬ̤ˤϼʬʬ̤
    !    * ήΤˤ, ʬʬ̤ϹθƤ뤿
    !
    
    !ۤηػ
    implicit none
    
    real(8), intent(in) :: a_MolFrIni(1:SpcNum)    !ǤΥ
    real(8), intent(in) :: Humidity                !м ( Humidity <= 1.0 )
    real(8), intent(out):: z_Temp(DimZMin:DimZMax) !
    real(8), intent(out):: z_Press(DimZMin:DimZMax)!
!    real(8), intent(out):: z_MolWtMean(DimZMin:DimZMax) 
    real(8)             :: z_MolWtMean(DimZMin:DimZMax) 
                                                   !ʿʬ
    real(8), intent(out):: za_MolFr(DimZMin:DimZMax, 1:SpcNum) 
                                                   !ʬΨ
    real(8)             :: MolWtMeanDry            !絤ʬ̤κѿ
    real(8)             :: MolWtMeanWet            !ᵤʬ̤κѿ
    real(8)             :: SatPress                !˰¾
    real(8)             :: VapPress                !
    real(8)             :: DelMolFr
    integer             :: k, s

    !-------------------------------------------------------------
    ! ν
    !-------------------------------------------------------------
    !ɽ̤ʬ̤
    za_MolFr(RegZMin+1, 1:SpcNum)   = a_MolFrIni(1:SpcNum) 

    !ɽ̤Ǥʿʬ̤
    MolWtMeanDry = MolWtDry * (1.0d0 - sum(a_MolFrIni))
    MolWtMeanWet = dot_product(MolWtWet, a_MolFrIni) 
    z_MolWtMean(RegZMin+1) = MolWtMeanDry + MolWtMeanWet
  
    !ɽ̤Ǥβ(RegZMin+1 ,  DelZ / 2 )
    z_Temp          = 1.0d-60
    z_Temp(RegZMin+1) = TempSfc - Grav * MolWtDry &
      &                 / CpDryMol * ( DelZ * 5.0d-1 )
    
    !ɽ̤Ǥΰ(RegZMin+1 ,  DelZ / 2 )
    z_Press           = 1.0d-60
    z_Press(RegZMin+1)  = &
      & PressSfc *((TempSfc / z_Temp(RegZMin+1)) ** (- CpDryMol /  GasRUniv))
    
    !-----------------------------------------------------------
    ! (1) Ǯ˱ä٤
    ! (2) ſ尵ʿդ鰵Ϥ
    ! (3) (1),(2) βٰϤФ, Ȥм٤Ȥʤ
    !-----------------------------------------------------------    
    DtDz: do k = RegZMin+1, DimZMax-1

      !(1)Ǯ˱ä k+1 Ǥβ٤׻
      z_Temp(k+1) = z_Temp(k) - Grav * MolWtDry / CpDryMol * DelZ
      
      !ǰ
      if (z_Temp(k+1) <= 0.0d0 ) z_Temp(k+1) = z_Temp(k) 
      
      !(2)Ϥſ尵ʿդ׻
      z_Press(k+1) =                                                  &
        &  z_Press(k) * ((z_Temp(k) / z_Temp(k+1)) ** (- CpDryMol / GasRUniv)) 

      !(3)η׻
      !  ޤϥѲʤΤȤƥͿ
      !  ˰¾ʿȤʿվŬѤƤ
      za_MolFr(k+1,:) = za_MolFr(k,:)
      
      do s = 1, CondNum      
        !˰¾
        SatPress = SvapPress( SpcWetID(IdxCC(s)), z_Temp(k+1) )        
        
        !ΥʬΨѤƸߤξ׻
        VapPress = za_MolFr(k,IdxCG(s)) * z_Press(k+1)
        
        !˰¾ȰϤ鸽ߤΥ׻
        if ( VapPress > SatPress ) then         
          za_MolFr(k+1,IdxCG(s)) = max(SatPress * Humidity / z_Press(k+1), 1.0d-16)

        end if
!        write(*,*) k, s, z_Temp(k), za_MolFr(k,IdxCG(s)), VapPress, SatPress
      end do
      
      !NH4SH ʿվ
      if ( IdxNH3 /= 0 ) then 
        DelMolFr =                                              &
          & max (                                               &
          &    DelMolFrNH4SH(                                   &
          &         z_Temp(k+1), z_Press(k+1),                  &
          &         za_MolFr(k+1,IdxNH3), za_MolFr(k+1,IdxH2S),       &
          &         Humidity                                    &
          &      ),                                             &
          &    0.0d0                                            &
          &  )
        za_MolFr(k+1,IdxNH3) = za_MolFr(k+1,IdxNH3) - DelMolFr
        za_MolFr(k+1,IdxH2S) = za_MolFr(k+1,IdxH2S) - DelMolFr
      end if
      
      !------------------------------------------------------------
      !ٸۤ׻
      !------------------------------------------------------------
      !ɽ̤Ǥʿʬ̤
      MolWtMeanDry = MolWtDry * (1.0d0 - sum(za_MolFr(k+1, 1:SpcNum)))
      MolWtMeanWet = dot_product(MolWtWet(1:SpcNum), za_MolFr(k+1, 1:SpcNum))
      z_MolWtMean(k+1) = MolWtMeanDry + MolWtMeanWet

    end do DtDz
    
  end subroutine ECCM_Dry


!!------------------------------------------------------------------------------!!!
!  subroutine ECCM_Wet( a_MolFrIni, Humidity, z_Temp, z_Press, z_MolWtMean, za_MolFr )
  subroutine ECCM_Wet( a_MolFrIni, Humidity, z_Temp, z_Press, za_MolFr )
    !
    !== 
    !  * ǮٸΨ˱ä١ϤᡢФƻꤵ줿м٤Ȥʤ褦˶ŷʬΥ
    !  * Ǯϴ絤ΤΤɽ
    !    * ήΤˤǮϴʬΤΤɽƤ뤿
    !  * 絤ʿʬ̤ˤϼʬʬ̤
    !    * ήΤˤ, ʬʬ̤ϹθƤ뤿
    !
    
    !ۤηػ
    implicit none
    
    real(8), intent(in) :: a_MolFrIni(1:SpcNum)    !ǤΥ
    real(8), intent(in) :: Humidity                !м ( Humidity <= 1.0 )
    real(8), intent(out):: z_Temp(DimZMin:DimZMax) !
    real(8), intent(out):: z_Press(DimZMin:DimZMax)!
!    real(8), intent(out):: z_MolWtMean(DimZMin:DimZMax) 
    real(8)             :: z_MolWtMean(DimZMin:DimZMax) 
                                                   !ʿʬ
    real(8), intent(out):: za_MolFr(DimZMin:DimZMax, 1:SpcNum) 
                                                   !ʬΨ
    real(8)             :: MolWtMeanDry            !絤ʬ̤κѿ
    real(8)             :: MolWtMeanWet            !ᵤʬ̤κѿ
    real(8)             :: SatPress                !˰¾
    real(8)             :: VapPress                !
    real(8)             :: DelMolFr
    integer             :: k, s, j
    
    real(8)             :: TempA, PressA, a_MolFrA(SpcNum)
    real(8)             :: TempN, PressN, a_MolFrN(SpcNum)
    real(8)             :: DZ
    real(8)             :: A, B
    real(8)             :: Heat(SpcNum)
    real(8)             :: ReactHeat
    logical             :: MoistFlag(SpcNum), ReactFlag
    
    !-------------------------------------------------------------
    ! ν
    !-------------------------------------------------------------
    !ɽ̤ʬ̤
    za_MolFr(RegZMin+1, 1:SpcNum)   = a_MolFrIni(1:SpcNum) 
    
    !ɽ̤Ǥʿʬ̤
    MolWtMeanDry = MolWtDry * (1.0d0 - sum(a_MolFrIni))
    MolWtMeanWet = dot_product(MolWtWet, a_MolFrIni) 
    z_MolWtMean(RegZMin+1) = MolWtMeanDry + MolWtMeanWet
  
    !ɽ̤Ǥβ(RegZMin+1 ,  DelZ / 2 )
    z_Temp          = 1.0d-60
    z_Temp(RegZMin+1) = TempSfc - Grav * MolWtDry / CpDryMol * ( DelZ * 5.0d-1 )

    !ɽ̤Ǥΰ(RegZMin ,  DelZ / 2 )
    z_Press           = 1.0d-60
    z_Press(RegZMin+1)  = PressSfc *((TempSfc / z_Temp(RegZMin+1)) ** (- CpDryMol /  GasRUniv))

    !-----------------------------------------------------------
    ! ǮΨ dT/dz η׻. 
    !-----------------------------------------------------------    
    DtDz: do k = RegZMin+1, DimZMax-1
      TempN  = z_Temp(k)
      PressN = z_Press(k)
      a_MolFrN = za_MolFr(k,:)
      
      DZ = DelZ/100
      do j = 1, 100
        MoistFlag = .false.
        Heat = 0.0d0   
        a_MolFrA = a_MolFrN  !
        
        !Ǯ˱ä k+1 Ǥβ٤׻
        TempA = TempN - Grav * MolWtDry / CpDryMol * DZ
!        write(*,*) "TempA", TempA
        
        !ǰ
        if (TempA <= 0.0d0 ) TempA = TempN
        
        !Ϥſ尵ʿդ׻
        PressA = PressN * ((TempN / TempA) ** (- CpDryMol / GasRUniv))
        
        ! ŷ뤬뤫Ƚ
        do s = 1, CondNum      
          !˰¾
          SatPress = SvapPress( SpcWetID(IdxCC(s)), TempA )
          
          !ΥʬΨѤƸߤξ׻
          VapPress = a_MolFrN(IdxCG(s)) * PressA
          
          !˰¾ŷ̵ͭ
          if ( VapPress < SatPress ) then         
            !ŷ뤷ƤʤΤǮʤ.
            a_MolFrA(IdxCG(s)) = a_MolFrN(IdxCG(s))
            !ŷ뤷ʤΤǮʤ
            Heat(IdxCG(s)) = 0.0d0
          else
            !Ǯ. ߤι٤Ǥ
            Heat(IdxCG(s)) = LatentHeatPerMol( SpcWetID(IdxCC(s)), TempN )
            !ŷΥå
            MoistFlag(s) = .true.
          end if
        end do

        !NH4SH ʿվ
        if ( IdxNH3 /= 0 ) then      
          DelMolFr =                                            &
            & max (                                             &
            &    DelMolFrNH4SH(                                 &
            &         TempA, PressA, a_MolFrN(IdxNH3), a_MolFrN(IdxH2S),&
            &         Humidity                                  &
            &      ),                                           &
            &    0.0d0                                          &
            &  )
          ! ȿǮ
          ReactHeat = ReactHeatNH4SHPerMol * DelMolFr
          ! ȿΥå
          if (DelMolFr > 0) ReactFlag = .true. 
        end if

!        write(*,*) "MoistFlag", MoistFlag
!        write(*,*) "ReactFlag", ReactFlag
        
        if (count(MoistFlag) > 0 .or. ReactFlag) then 
          !.  k Ǥͤɾ
          A = dot_product( Heat(1:SpcNum), a_MolFrN(1:SpcNum)) / ( GasRUniv * TempN )
          B = dot_product(( Heat(1:SpcNum) ** 2.0d0), a_MolFrN(1:SpcNum)) &
            & / ( CpDryMol * GasRUniv * ( TempN ** 2.0d0 ) )
          
          !ǮٸΨ
          TempA = TempN - Grav * MolWtDry * (1.0d0 + A) / (CpDryMol * (1.0d0 + B)) * DZ &
            &       + ReactHeat / (CpDryMol * DelZ)
!          write(*,*) "Moist TempA",   TempA
!          write(*,*) "Moist Heat ",   Heat
!          write(*,*) "Moist MolFr ",  a_MolFrN
!          write(*,*) "Moist DTempDZ", - Grav * MolWtDry * (1.0d0 + A) / (CpDryMol * (1.0d0 + B))
          
          !ǰ
          if (TempA <= 0.0d0 ) TempA = TempN
          
          !Ϥſ尵ʿդ׻
          PressA = PressN * ((TempN / TempA) ** (- CpDryMol / GasRUniv)) 
          
          do s = 1, CondNum              
            if (MoistFlag(s)) then 
              !˰¾
              SatPress = SvapPress( SpcWetID(IdxCC(s)), TempA )
              ! ˰¥
              a_MolFrA(IdxCG(s)) = max(SatPress / PressA, 1.0d-16)
            else
              ! ΥƱ
              a_MolFrA(IdxCG(s)) = a_MolFrN(IdxCG(s)) 
            end if
          end do

          if ( ReactFlag ) then 
            DelMolFr =                                            &
              & max (                                             &
              &    DelMolFrNH4SH(                                 &
              &         TempA, PressA, a_MolFrA(IdxNH3), a_MolFrA(IdxH2S),&
              &         Humidity                                  &
              &      ),                                           &
              &    0.0d0                                          &
              &  )
            a_MolFrA(IdxNH3) = a_MolFrA(IdxNH3) - DelMolFr
            a_MolFrA(IdxH2S) = a_MolFrA(IdxH2S) - DelMolFr
          end if
        end if
        
        TempN  = TempA
        PressN = PressA
        a_MolFrN = a_MolFrA        
      end do
        
      z_Temp(k+1)     = TempA
      z_Press(k+1)    = PressA
      za_MolFr(k+1,:) = a_MolFrA(:)
      
      !ʿʬ̤
      MolWtMeanDry = MolWtDry * (1.0d0 - sum(za_MolFr(k+1, 1:SpcNum)))
      MolWtMeanWet = dot_product(MolWtWet(1:SpcNum), za_MolFr(k+1, 1:SpcNum))
      z_MolWtMean(k+1) = MolWtMeanDry + MolWtMeanWet
    end do DtDz
    
  end subroutine ECCM_Wet


!!------------------------------------------------------------------------------!!!
  subroutine ECCM_Wet2( Idx, Humidity, z_Temp, z_Press, za_MolFr)
    !
    !== 
    !  * ǮٸΨ˱ä١ϤᡢФƻꤵ줿м٤Ȥʤ褦˶ŷʬΥ
    !  * Ǯϴ絤ΤΤɽ
    !    * ήΤˤǮϴʬΤΤɽƤ뤿
    !  * 絤ʿʬ̤ˤϼʬʬ̤
    !    * ήΤˤ, ʬʬ̤ϹθƤ뤿
    !
    
    !ۤηػ
    implicit none
    
    integer             :: Idx
    real(8), intent(inout) :: z_Temp(DimZMin:DimZMax)    !ǤΥ
    real(8), intent(inout) :: z_Press(DimZMin:DimZMax) !ǤΥ
    real(8), intent(inout) :: za_MolFr(DimZMin:DimZMax, 1:SpcNum)    !ǤΥ
    real(8), intent(in) :: Humidity                !м ( Humidity <= 1.0 )
    real(8)             :: SatPress                !˰¾
    real(8)             :: VapPress                !
    real(8)             :: DelMolFr
    integer             :: k, s, j
    
    real(8)             :: TempA, PressA, a_MolFrA(SpcNum)
    real(8)             :: TempN, PressN, a_MolFrN(SpcNum)
    real(8)             :: DZ
    real(8)             :: A, B
    real(8)             :: Heat(SpcNum)
    real(8)             :: ReactHeat
    logical             :: MoistFlag(SpcNum), ReactFlag
    

    !-----------------------------------------------------------
    ! ǮΨ dT/dz η׻. 
    !-----------------------------------------------------------    
    DtDz: do k = Idx, DimZMax-1
      TempN  = z_Temp(k)
      PressN = z_Press(k)
      a_MolFrN = za_MolFr(k,:)
      
      DZ = DelZ/100
      do j = 1, 100
        MoistFlag = .false.
        Heat = 0.0d0   
        a_MolFrA = a_MolFrN  !
        
        !Ǯ˱ä k+1 Ǥβ٤׻
        TempA = TempN - Grav * MolWtDry / CpDryMol * DZ
!        write(*,*) "TempA", TempA
        
        !ǰ
        if (TempA <= 0.0d0 ) TempA = TempN
        
        !Ϥſ尵ʿդ׻
        PressA = PressN * ((TempN / TempA) ** (- CpDryMol / GasRUniv))
        
        ! ŷ뤬뤫Ƚ
        do s = 1, CondNum      
          !˰¾
          SatPress = SvapPress( SpcWetID(IdxCC(s)), TempA )
          
          !ΥʬΨѤƸߤξ׻
          VapPress = a_MolFrN(IdxCG(s)) * PressA
          
          !˰¾ŷ̵ͭ
          if ( VapPress < SatPress ) then         
            !ŷ뤷ƤʤΤǮʤ.
            a_MolFrA(IdxCG(s)) = a_MolFrN(IdxCG(s))
            !ŷ뤷ʤΤǮʤ
            Heat(IdxCG(s)) = 0.0d0
          else
            !Ǯ. ߤι٤Ǥ
            Heat(IdxCG(s)) = LatentHeatPerMol( SpcWetID(IdxCC(s)), TempN )
            !ŷΥå
            MoistFlag(s) = .true.
          end if
        end do

        !NH4SH ʿվ
        if ( IdxNH3 /= 0 ) then      
          DelMolFr =                                            &
            & max (                                             &
            &    DelMolFrNH4SH(                                 &
            &         TempA, PressA, a_MolFrN(IdxNH3), a_MolFrN(IdxH2S),&
            &         Humidity                                  &
            &      ),                                           &
            &    0.0d0                                          &
            &  )
          ! ȿǮ
          ReactHeat = ReactHeatNH4SHPerMol * DelMolFr
          ! ȿΥå
          if (DelMolFr > 0) ReactFlag = .true. 
        end if

!        write(*,*) "MoistFlag", MoistFlag
!        write(*,*) "ReactFlag", ReactFlag
        
        if (count(MoistFlag) > 0 .or. ReactFlag) then 
          !.  k Ǥͤɾ
          A = dot_product( Heat(1:SpcNum), a_MolFrN(1:SpcNum)) / ( GasRUniv * TempN )
          B = dot_product(( Heat(1:SpcNum) ** 2.0d0), a_MolFrN(1:SpcNum)) &
            & / ( CpDryMol * GasRUniv * ( TempN ** 2.0d0 ) )
          
          !ǮٸΨ
          TempA = TempN - Grav * MolWtDry * (1.0d0 + A) / (CpDryMol * (1.0d0 + B)) * DZ &
            &       + ReactHeat / (CpDryMol * DZ)
!          write(*,*) "Moist TempA",   TempA
!          write(*,*) "Moist Heat ",   Heat
!          write(*,*) "Moist MolFr ",  a_MolFrN
!          write(*,*) "Moist DTempDZ", - Grav * MolWtDry * (1.0d0 + A) / (CpDryMol * (1.0d0 + B))
          
          !ǰ
          if (TempA <= 0.0d0 ) TempA = TempN
          
          !Ϥſ尵ʿդ׻
          PressA = PressN * ((TempN / TempA) ** (- CpDryMol / GasRUniv)) 
          
          do s = 1, CondNum              
            if (MoistFlag(s)) then 
              !˰¾
              SatPress = SvapPress( SpcWetID(IdxCC(s)), TempA )
              ! ˰¥
              a_MolFrA(IdxCG(s)) = max(SatPress / PressA, 1.0d-16)
            else
              ! ΥƱ
              a_MolFrA(IdxCG(s)) = a_MolFrN(IdxCG(s)) 
            end if
          end do

          if ( ReactFlag ) then 
            DelMolFr =                                            &
              & max (                                             &
              &    DelMolFrNH4SH(                                 &
              &         TempA, PressA, a_MolFrA(IdxNH3), a_MolFrA(IdxH2S),&
              &         Humidity                                  &
              &      ),                                           &
              &    0.0d0                                          &
              &  )
            a_MolFrA(IdxNH3) = a_MolFrA(IdxNH3) - DelMolFr
            a_MolFrA(IdxH2S) = a_MolFrA(IdxH2S) - DelMolFr
          end if
       end if
        
        TempN  = TempA
        PressN = PressA
        a_MolFrN = a_MolFrA        
      end do
        
      z_Temp(k+1)     = TempA
      z_Press(k+1)    = PressA
      za_MolFr(k+1,:) = a_MolFrA(:)
      
   end do DtDz
    
  end subroutine ECCM_Wet2

!!------------------------------------------------------------------------------!!!
!!------------------------------ꥸʥ--------------------------------------!!!
!!------------------------------------------------------------------------------!!!

  subroutine HUM(z_humid, kansoku_altitude, kansoku_HumZ)

!!!------!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!! Yamasaki, 1983 δܾѤ뤿, Ʊʸм٤δ¬ǡ !!
!! netCDF ե벽ΤäƤץ                   !!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

    implicit none

    real(8) :: Observed_Humidity(1:100,1:88)!NetCDF м٤ɤ߹
    real(8),intent(out) :: z_humid(DimZMin:DimZMax)
    real(8),intent(out) :: kansoku_altitude(1:88)       !¬ǡδֳ
    real(8),intent(out) :: kansoku_HumZ(1:88)           !м٤δ¬(BasicZ )
    integer :: k,m

    z_humid = 0.0d0
    kansoku_altitude = 0.0d0
    kansoku_HumZ = 0.0d0

 do m = 1,88
  kansoku_altitude(m) = 25.0d1*(m-1)      ! ¬ǡǤι
 end do

!!-- NetCDF ե뤫εм٤ɤ߹ --!!


  call HistoryGet('Ob_Humidity.nc', 'Ob_Humidity', array=Observed_Humidity)

!!-- ̥ץǺ Ob_Humidity.nc 󼡸ǡ (x,z) ʤΤ --!!
!!-- 켡ˤ                                                      --!!

  do m=1,88
      kansoku_HumZ(m)  = Observed_Humidity(1,m)
  end do

!!-- Ob_HumZ 䴰 HumZ ͤͿ --!!

! z_HumZ(RegZMin) = 83.0d0

 do k = RegZMin+1,DimZMax
  do m = 1,87

    if (kansoku_altitude(m).ne.s_Z(k).and.s_Z(k).gt.kansoku_altitude(m) &
       & .and.s_Z(k).lt.kansoku_altitude(m+1)) then

      z_humid(k) = kansoku_HumZ(m)+((kansoku_HumZ(m+1) - kansoku_HumZ(m)) &
       & /(kansoku_altitude(m+1)-kansoku_altitude(m)))*(s_Z(k)-kansoku_altitude(m))

    else if (kansoku_altitude(m).eq.s_Z(k)) then

      z_humid(k) = kansoku_HumZ(m)

    else if (kansoku_altitude(m).lt.s_Z(k)) then

      z_humid(k) = z_humid(k-1)

    end if

   end do
  end do
end subroutine HUM

!!------------------------------------------------------------------------------!!!
  subroutine ECCM_Ima( a_MolFrIni, Humidity, z_Temp, z_Press, z_MolWtMean, za_MolFr )

!!!--- ---!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!! Yamasaki, 1983 δܾƸץ.                             !
!! м٤ HUM ƤƥѴ.                           !
!! ϤΥץ,  netCDF ե뤫äƤ.          !
!! Τ褦ˤΤм٤äƤ뤫 write ʸǳǧ뤿. !
!! ʤ, ſ尵ʿդ׻.                                      !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

    implicit none

    real(8), intent(in):: a_MolFrIni(1:SpcNum)    !ǤΥ
    real(8), intent(in) :: Humidity                !м ( Humidity <= 1.0 )
    real(8), intent(out):: z_MolWtMean(DimZMin:DimZMax)
    real(8), intent(out):: z_Press(DimZMin:DimZMax)!
    real(8), intent(out):: z_Temp(DimZMin:DimZMax) !
    real(8), intent(out):: za_MolFr(DimZMin:DimZMax, 1:SpcNum)
    real(8)             :: MolWtMeanDry            !絤ʬ̤κѿ
    real(8)             :: MolWtMeanWet            !ᵤʬ̤κѿ
!    real(8)             :: SatPress                !˰¾
!    real(8)             :: VapPress                !
!    real(8)             :: DelMolFr
!    real(8)             :: a_MolFr(SpcNum)         !κ
    real(8) :: Ob_altitude(1:88)       !¬ǡδֳ
    real(8) :: Ob_TempZ(1:89)          !δ¬(BasicZ )
    real(8) :: Ob_HumZ(1:88)               !м٤δ¬(BasicZ )
    real(8) :: z_PressSaturated(DimZMin:DimZMax)
    real(8) :: z_HumZ(DimZMin:DimZMax)
    real(8) :: Observed_Temp(1:100,1:89)   !NetCDF 鵤ɤ߹
    real(8) :: Observed_Humidity(1:100,1:88)!NetCDF м٤ɤ߹
    integer             :: k, s, i, m, b

    z_HumZ = 0.0d0

    call HUM(z_HumZ, Ob_altitude, Ob_HumZ)

! do m = 1,88
!  Ob_altitude(m) = 25.0d1*(m-1)      ! ¬ǡǤι
! end do

!!-- NetCDF ե뤫εм٤ɤ߹ --!!

  call HistoryGet('Ob_Temp.nc', 'Ob_Temp', array=Observed_Temp)

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!----  ----!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!-- ̥ץǺ Ob_Temp.nc 󼡸ǡ (x,z) ʤΤ --!
!!-- 켡 (z) ˤ                                             --!

  do m=1,89
      Ob_TempZ(m) = Observed_Temp(1,m)
  end do

!!-- Ob_TempZ 䴰 Temp ͤͿ --!!


 z_Temp = 1.0d-60      ! 

 do k = RegZMin+1,DimZMax
  do m = 1,88

    !! s_Z  Ob_altitude Τ֤˶ޤȤ,
    !! ζ֤ Obaltitude(m), Obaltitude(m+1) 
    !! ľ Temp ֤

    if (Ob_altitude(m).ne.s_Z(k).and.s_Z(k).gt.Ob_altitude(m) &
       & .and.s_Z(k).lt.Ob_altitude(m+1)) then

      z_Temp(k) = Ob_TempZ(m)+((Ob_TempZ(m+1)-Ob_TempZ(m)) &
       & /(Ob_altitude(m+1)-Ob_altitude(m)))*(s_Z(k)-Ob_altitude(m))

    !!
    !! s_Z(k) = Obaltitude(i) λ, Ob_TempZ(i) = Temp(k) Ȥʤ
    !!

    else if (Ob_altitude(m).eq.s_Z(k)) then

      z_Temp(k) = Ob_TempZ(m)

    !!
    !! s_Z(k) > Ob_altitude Ǥϴ¬ǡ̵ΤǤȤꤢ絤ˤ
    !!

    else if (Ob_altitude(m).lt.s_Z(k)) then

      z_Temp(k) = z_Temp(k-1)

    end if

   end do
  end do

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!--- ʬΨη׻ ---!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

 z_Press = 1.0d-60              ! 

!!!--ɽ̵٤絤ǲؤε--!!!

 z_Press(RegZMin+1) = &
         & PressSfc - (Grav * PressSfc * DelZ) &
         & /((GasRUniv/ &
         & (MolWtMeanDry + (MolWtMeanWet - MolWtMeanDry) &
         & *SvapPress(6,TempSfc) &
         & *z_HumZ(RegZMin+1) / PressSfc)) &  !! ɽ̤м٤絤ǲؤΤΤ
         & *TempSfc)

! z_Press(RegZMin+1) = 997.750d2  !  125 m ε. (ɽ̵ 1010 hPa)

!  za_MolFr(RegZMin+1,1:SpcNum) = a_MolFrIni(1:SpcNum) ! ɽ̤ǤΥ, SpcWetMolFr Ϳ
!  MolWtMeanDry = MolWtDry * (1.0d0 - sum(a_MolFrIni)) ! ɽ̤Ǥδ絤ʬ
!  MolWtMeanWet = dot_product(MolWtWet, a_MolFrIni)    ! ɽ̤Ǥμ絤ʬ 

  za_MolFr(RegZMin+1,1) = SvapPress( 6,z_Temp(RegZMin+1)) * &         ! 絤ǲؤΥ
                        & (z_HumZ(RegZMin+1)/100)/z_Press(RegZMin+1)  ! SpcWetMolFr Ϳʤ

  MolWtMeanDry = MolWtDry * 1.0d0 - za_MolFr(RegZMin+1,1)! ɽ̤Ǥδ絤ʬ
  MolWtMeanWet = MolWtWet(1) * za_MolFr(RegZMin+1,1)     ! ɽ̤Ǥμ絤ʬ 

  z_MolWtMean(RegZMin+1) = MolWtMeanDry + MolWtMeanWet


 do k=RegZMin+1,DimZMax

   z_PressSaturated(k) = 6.11*(10**(7.5*(z_Temp(k)-273)/(z_Temp(k)-35.7)))*100

 end do
   ! ˰¾ Tetens(1930) .
   ! , Tetens(1930) μβ٤ [] Ǥ, ޤ [hPa] ǽФƤΤ
   ! ŬѤƤ.


 do k = RegZMin+1,DimZMax-1

!   do s = 1,CondNum
!   
!    za_MolFr(k,IdxCG(s)) = SvapPress( SpcWetID(IdxCC(s)),z_Temp(k))* &
!                           & (z_HumZ(k)/100)/z_Press(k)
!   end do

    za_MolFr(k,1) = SvapPress( 6,z_Temp(k))* (z_HumZ(k)/100)/z_Press(k)


!  MolWtMeanDry = MolWtDry * (1.0d0 - sum(za_MolFr(k,1:SpcNum)))
!  MolWtMeanWet = dot_product(MolWtWet, za_MolFr(k,1:SpcNum))
   MolWtMeanDry = MolWtDry * (1.0d0 - za_MolFr(k,1))
   MolWtMeanWet = MolWtWet(1) * za_MolFr(k,1)
   z_MolWtMean(k) = MolWtMeanDry + MolWtMeanWet

   z_Press(k+1) = &
       & z_Press(k)-(Grav*z_Press(k)*DelZ) &
       & /((GasRUniv/ &
       & (MolWtMeanDry + (MolWtMeanWet - MolWtMeanDry) &
       & *SvapPress(6,z_Temp(k)) &
       & *(z_HumZ(k)/100)/z_Press(k))) &
       & *z_Temp(k))

 end do


!!!!!!!!
!!!!!!!!MolWtMean 
!!!!!!!!â, ºݤ MolWtMeanDry  MolWtMeanWet Ѥ
!!!!!!!!...
!!!!!!!!
! do k = RegZMin+1,DimZMax-1
!   z_MolWtMean(k) = MolWtMeanDry + MolWtMeanWet
! end do

!!!!!!!!!
!!!!!!!!!

 end subroutine ECCM_Ima

!!!------------------------------------------------------------------------------!!!
  subroutine Height(B,U)

!!!!! ץबǧ뤿Τ !!!!!!
!!!!! ä˰̣Ϥʤ.                            !!!!!!

    implicit none

    integer,intent(out) :: B
    integer,intent(out) :: U
    integer :: k
  do k = RegZMin+1, DimZMax
   if (s_Z(k).ge.2500.and.s_Z(k).le.(2500 + DelZ)) then
!   if (s_Z(k).ge.2500.and.s_Z(k+1).le.(5000 + DelZ)) then
     B = k
   end if
  end do

  do k = RegZMin+1, DimZMax
   if (s_Z(k).ge.5000.and.s_Z(k).le.(5000 + DelZ)) then
!   if (s_Z(k).ge.5000.and.s_Z(k).le.(5000 + DelZ)) then
     U = k
   end if
  end do 

  end subroutine Height
!!!------------------------------------------------------------------------------!!!
  subroutine HUM_Takemi2007(z_RH,Ztr,TR,LL)

!!!---  ---!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!! deepconv ưƤ뤫ǧ뤿, Takemi, 2007      !
!! ͤ, 絤԰ꡦʾѱήο񤤤򸫤뤿 !
!! ܾץ                                       !
!! Takemi, 2007 ǸȤǮӡپ "BASE" Ƹ.     !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

    implicit none

    real(8),intent(out) :: z_RH(DimZMin:DimZMax) !Relative Humidity, Takemi, 2007 Ǥ̾
    real(8),intent(out) :: Ztr !ή̤ι. Takemi, 2007  z_tr 
    integer,intent(out) :: TR  !ή̤γʻֹ
    integer,intent(out) :: LL  ! 1.5 km ľγʻֹ (Low Level)
    integer :: k

    z_RH = 0.0d0
    Ztr  = 0.0d0

!!! ޤή̹٤Ϳ. Takemi, 2007 Ǥ 12 km , ɬʻ
!!! 礦 12 km ˤϾʤΤ, 12 km , 12 km ľγʻΰ֤ή̤ˤ


    do k = RegZMin+1,DimZMax

!! s_Z  礦 12 km ʤ 12 km ή

     if (s_Z(k).eq.12000) then

       Ztr = s_Z(k)

!! s_Z 礦 12 km ˤʤʤä 12 km 礭 s_Z κǾ s_Z ή̤ˤ

     else if (s_Z(k).gt.12000) then

       Ztr = minval( s_Z, 1, s_Z > 12000 )

     end if
    end do

!! ή̹٤γʻ (Ztr = s_Z(TR))

    do k = RegZMin+1,DimZMax

      if (s_Z(k).ge.12000.and.s_Z(k).le.(12000 + DelZ)) then

        TR = k

      end if

    end do

    do k = RegZMin+1,DimZMax

     if (s_Z(k).le.1500.and.s_Z(k).ge.(1500 - DelZ)) then

       LL = k

      end if

    end do

!! Takemi, 2007 μѤм٤
!! ,  1.5 km ʲǤǤդκ (q_v0) Ϳ뤿,
!! ʲμ 1.5 km м٤ΤǤ.

    do k = RegZMin+1, DimZMax

      if (k.le.LL) then

        z_RH(k) = 0.0d0

!     if (s_Z(k).le.Ztr.and.s_Z(k).gt.1500) then
      else if (k.le.TR.and.k.gt.LL) then

        z_RH(k) = 1.0d0 - 0.750d0 * (s_Z(k) / Ztr)**1.25 !! (4/5) ǤϤ٤褬ǧʤ
                                                         !! ʤ?

!     else if (s_Z(k).gt.Ztr) then
      else if (k.gt.TR) then

        z_RH(k) = 0.25

      end if

     end do

   end subroutine HUM_Takemi2007

!!!------------------------------------------------------------------------------!!!
  subroutine HUM_Takemi2007_TDRY(z_RH,Ztr,TR,LL)


!!!---  ---!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!! deepconv ưƤ뤫ǧ뤿, Takemi, 2007      !
!! ͤ, 絤԰ꡦʾѱήο񤤤򸫤뤿 !
!! ܾץ                                       !
!! Takemi, 2007 ǸȤǮӾ "DRY" Ƹ.              !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

    implicit none

    real(8),intent(out) :: z_RH(DimZMin:DimZMax) !Relative Humidity, Takemi, 2007 Ǥ̾
    real(8),intent(out) :: Ztr !ή̤ι. Takemi, 2007  z_tr 
    integer,intent(out) :: TR  !ή̤γʻֹ
    integer,intent(out) :: LL  ! 1.5 km ľγʻֹ (Low Level)
    integer :: k

    z_RH = 0.0d0
    Ztr  = 0.0d0

!!! ޤή̹٤Ϳ. Takemi, 2007 Ǥ 12 km , ɬʻ
!!! 礦 12 km ˤϾʤΤ, 12 km , 12 km ľγʻΰ֤ή̤ˤ


    do k = RegZMin+1,DimZMax

!! s_Z  礦 12 km ʤ 12 km ή

     if (s_Z(k).eq.12000) then

       Ztr = s_Z(k)

!! s_Z 礦 12 km ˤʤʤä 12 km 礭 s_Z κǾ s_Z ή̤ˤ

     else if (s_Z(k).gt.12000) then

       Ztr = minval( s_Z, 1, s_Z > 12000 )

     end if
    end do

!! ή̹٤γʻ (Ztr = s_Z(TR))

    do k = RegZMin+1,DimZMax

      if (s_Z(k).ge.12000.and.s_Z(k).le.(12000 + DelZ)) then

        TR = k

      end if

    end do

    do k = RegZMin+1,DimZMax

     if (s_Z(k).le.1500.and.s_Z(k).ge.(1500 - DelZ)) then

       LL = k

      end if

    end do

!! Takemi, 2007 μѤм٤
!! ,  1.5 km ʲǤǤդκ (q_v0) Ϳ뤿,
!! ʲμ 1.5 km м٤ΤǤ.
!! , 絤Υȥ쥤ȤθǮӤ DRY 
!! پǤ,  2.5 km, 5.0 km, 7.5 km м٤ 20 % 
!! DRY1,2,3 Ѱդ.

    do k = RegZMin+1, DimZMax

      if (k.le.LL) then

        z_RH(k) = 0.0d0

!! 1.5 km  (2.5 km, 5.0 km, 7.5 km) ޤǤϤΤޤѲ

!      else if (s_Z(k).lt.2500.and.k.gt.LL) then   ! DRY1
!      else if (s_Z(k).lt.5000.and.k.gt.LL) then   ! DRY2
      else if (s_Z(k).lt.7500.and.k.gt.LL) then   ! DRY3

        z_RH(k) = 1.0d0 - 0.750d0 * (s_Z(k) / Ztr)**1.25

!! (2.5 km, 5.0 km, 7.5 km) ʹߤ 20 % 

!      else if (s_Z(k).ge.2500) then   ! DRY1
!      else if (s_Z(k).ge.5000) then   ! DRY2
      else if (s_Z(k).ge.7500) then   ! DRY3

        z_RH(k) = 1.0d0 - 0.750d0 * (s_Z(k) / Ztr)**1.25 - 0.20d0

      end if

     end do

!! м٤ 25 % ʲˤʤ.

    do k = RegZMin+1, DimZMax

      if (z_RH(k).le.(0.25).and.k.gt.LL) then

        z_RH(k) = 0.250d0

      end if

    end do

   end subroutine HUM_Takemi2007_TDRY

!!!------------------------------------------------------------------------------!!!
  subroutine HUM_Takemi2007_MDRY(z_RH,Ztr,TR,LL)

!!!---  ---!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!! deepconv ưƤ뤫ǧ뤿, Takemi, 2007      !
!! ͤ, 絤԰ꡦʾѱήο񤤤򸫤뤿 !
!! ܾץ                                       !
!! Takemi, 2007 ǸȤپ "DRY" Ƹ.            !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

    implicit none

    real(8),intent(out) :: z_RH(DimZMin:DimZMax) !Relative Humidity, Takemi, 2007 Ǥ̾
    real(8),intent(out) :: Ztr !ή̤ι. Takemi, 2007  z_tr 
    integer,intent(out) :: TR  !ή̤γʻֹ
    integer,intent(out) :: LL  ! 1.5 km ľγʻֹ (Low Level)
    integer :: k

    z_RH = 0.0d0
    Ztr  = 0.0d0

!!! ޤή̹٤Ϳ. Takemi, 2007 Ǥ 12 km , ɬʻ
!!! 礦 12 km ˤϾʤΤ, 12 km , 12 km ľγʻΰ֤ή̤ˤ


    do k = RegZMin+1,DimZMax

!! s_Z  礦 12 km ʤ 12 km ή

     if (s_Z(k).eq.12000) then

       Ztr = s_Z(k)

!! s_Z 礦 12 km ˤʤʤä 12 km 礭 s_Z κǾ s_Z ή̤ˤ

     else if (s_Z(k).gt.12000) then

       Ztr = minval( s_Z, 1, s_Z > 12000 )

     end if
    end do

!! ή̹٤γʻ (Ztr = s_Z(TR))

    do k = RegZMin+1,DimZMax

      if (s_Z(k).ge.12000.and.s_Z(k).le.(12000 + DelZ)) then

        TR = k

      end if

    end do

    do k = RegZMin+1,DimZMax

     if (s_Z(k).le.1500.and.s_Z(k).ge.(1500 - DelZ)) then

       LL = k

      end if

    end do

!! Takemi, 2007 μѤм٤
!! ,  1.5 km ʲǤǤդκ (q_v0) Ϳ뤿,
!! ʲμ 1.5 km м٤ΤǤ.
!! , 絤Υȥ쥤Ȥθ٤ DRY 
!! پǤ,  2.5 km м٤ 13 % ⤷ 30 % 
!! DRY1,2 Ѱդ.

    do k = RegZMin+1, DimZMax

      if (k.le.LL) then

        z_RH(k) = 0.0d0

!! 1.5 km 2.5 km ޤǤϤΤޤѲ

      else if (s_Z(k).lt.2500.and.k.gt.LL) then

        z_RH(k) = 1.0d0 - 0.750d0 * (s_Z(k) / Ztr)**1.25

!! 2.5 km ʹߤ 13 % or 30 % 

      else if (s_Z(k).ge.2500) then

!        z_RH(k) = 1.0d0 - 0.750d0 * (s_Z(k) / Ztr)**1.25 - 0.13d0   ! DRY1
         z_RH(k) = 1.0d0 - 0.750d0 * (s_Z(k) / Ztr)**1.25 - 0.30d0   ! DRY2

      end if

     end do

!! м٤ 25 % ʲˤʤ.

    do k = RegZMin+1, DimZMax

      if (z_RH(k).le.(0.25).and.k.gt.LL) then

        z_RH(k) = 0.250d0

      end if

    end do

   end subroutine HUM_Takemi2007_MDRY
!!!------------------------------------------------------------------------------!!!
  subroutine ECCM_Takemi2007( a_MolFrIni, Humidity, z_Temp, z_Press, z_MolWtMean, za_MolFr, z_LLhumidity )
    implicit none

    real(8), intent(in):: a_MolFrIni(1:SpcNum)    !ǤΥ
    real(8), intent(in) :: Humidity                !м ( Humidity <= 1.0 )
    real(8), intent(out):: z_MolWtMean(DimZMin:DimZMax)
    real(8), intent(out):: z_Press(DimZMin:DimZMax)!
    real(8), intent(out):: z_Temp(DimZMin:DimZMax) !
    real(8), intent(out):: za_MolFr(DimZMin:DimZMax, 1:SpcNum)
    real(8), intent(out) :: z_LLhumidity(DimZMin:DimZMax)  ! 1.5 km ޤǤм
    real(8)             :: MolWtMeanDry            !絤ʬ̤κѿ
    real(8)             :: MolWtMeanWet            !ᵤʬ̤κѿ
!! Takemi, 2007 Ѥ뤿ɬפʤΤ-------
    real(8) :: z_TakemiRH(DimZMin:DimZMax)
    real(8) :: z_TakemiTheta(DimZMin:DimZMax)
    real(8) :: Theta_0  ! ɽ̤β
    real(8) :: Theta_tr ! ή̤β
    real(8) :: TakemiZtr ! ή̤ι
    real(8) :: HumSfc    ! ɽ̤м
    real(8) :: a_MolFrSfc ! ɽ̤Υ
!!--------------------------------------------------
    integer             :: k, s, i, m, b, T, L

    z_TakemiRH = 0.0d0
    z_TakemiTheta = 0.0d0

    call HUM_Takemi2007(z_TakemiRH,TakemiZtr,T,L)
!    call HUM_Takemi2007_TDRY(z_TakemiRH,TakemiZtr,T,L)
!     call HUM_Takemi2007_MDRY(z_TakemiRH,TakemiZtr,T,L)

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!Takemi, 2007 ˤ벹̾!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

   Theta_0 = 300.0d0

   Theta_tr = 343.0d0     ! 
!  Theta_tr = 358.0d0     ! Ǯ

  z_TakemiTheta(RegZMin+1) = Theta_0 + &
                           & (Theta_tr - Theta_0)*(s_Z(RegZMin+1) / TakemiZtr)**1.25

  z_Temp  = 1.0d-60
  z_Press = 1.0d-60
  z_LLhumidity = 0.0d0

!!!!----絤ǲؤε桦ʬ----!!!!

!!!--ɽ̵٤絤ǲؤε--!!!

!  a_MolFrSfc = 0.0180d0 * MolWtDry / MolWtWet(1)  ! Q18
!  a_MolFrSfc = 0.0160d0 * MolWtDry / MolWtWet(1)  ! Q16
   a_MolFrSfc = 0.0140d0 * MolWtDry / MolWtWet(1)  ! Q14
!  a_MolFrSfc = 0.0120d0 * MolWtDry / MolWtWet(1)  ! Q12
!  a_MolFrSfc = 0.0100d0 * MolWtDry / MolWtWet(1)  ! Q10 

   MolWtMeanDry = MolWtDry * (1 - a_MolFrSfc)
   MolWtMeanWet = MolWtWet(1) * a_MolFrSfc

   HumSfc = a_MolFrSfc * PressSfc / SvapPress(6,TempSfc)

   z_Press(RegZMin+1) = &
           & PressSfc - (Grav * PressSfc * DelZ) &
           & /((GasRUniv/ &
           & (MolWtMeanDry + (MolWtMeanWet - MolWtMeanDry) &
           & *SvapPress(6,TempSfc) &
           & *HumSfc / PressSfc)) &
           & *TempSfc)

!  z_Press(RegZMin+1) = 987.750d2  !  125 m ε. (ɽ̵ 1000 hPa)
 
   z_Temp(RegZMin+1) = z_TakemiTheta(RegZMin+1) * (z_Press(RegZMin+1) / 100000.0d0)**(GasRDry / CpDry)


!  za_MolFr(RegZMin+1,1) = 0.0180d0 * MolWtDry / MolWtWet(1)  ! Q18(١Ǯ)
!  za_MolFr(RegZMin+1,1) = 0.0160d0 * MolWtDry / MolWtWet(1)  ! Q16
   za_MolFr(RegZMin+1,1) = 0.0140d0 * MolWtDry / MolWtWet(1)  ! Q14
!  za_MolFr(RegZMin+1,1) = 0.0120d0 * MolWtDry / MolWtWet(1)  ! Q12
!  za_MolFr(RegZMin+1,1) = 0.0100d0 * MolWtDry / MolWtWet(1)  ! Q10
 
   MolWtMeanDry = MolWtDry * (1 - za_MolFr(RegZMin+1,1))
   MolWtMeanWet = MolWtWet(1) * za_MolFr(RegZMin+1,1)

   z_LLhumidity(RegZMin+1) = za_MolFr(RegZMin+1,1) * z_Press(RegZMin+1) / SvapPress(6,z_Temp(RegZMin+1))

!!!!--------------------------------------------!!!!

  do k = RegZMin+1, DimZMax

!! 絤ǲؤ 1.5 km (k  L ʲ) ʲξ

   if (k.le.L-1) then
!     za_MolFr(k+1,1) = 0.0180d0 * MolWtDry / MolWtWet(1) !! Takemi, 2007 Ǥ絤 1.5 km κ
!                                                         !! 10 - 18 g/kg ѲͿƤ
!     za_MolFr(k+1,1) = 0.0160d0 * MolWtDry / MolWtWet(1)
      za_MolFr(k+1,1) = 0.0140d0 * MolWtDry / MolWtWet(1)
!     za_MolFr(k+1,1) = 0.0120d0 * MolWtDry / MolWtWet(1)
!     za_MolFr(k+1,1) = 0.0100d0 * MolWtDry / MolWtWet(1)
 
     z_Press(k+1) = &
         & z_Press(k)-(Grav*z_Press(k)*DelZ) &
         & /((GasRUniv/ &
         & (MolWtMeanDry + (MolWtMeanWet - MolWtMeanDry) &
         & *SvapPress(6,z_Temp(k)) &
         & *z_LLhumidity(k)/z_Press(k))) &
         & *z_Temp(k))

     MolWtMeanDry = MolWtDry * (1 - za_MolFr(k+1,1))
     MolWtMeanWet = MolWtWet(1) * za_MolFr(k+1,1)
     z_MolWtMean = MolWtMeanDry + MolWtMeanWet

     z_TakemiTheta(k+1) = Theta_0 + (Theta_tr - Theta_0)*(s_Z(k+1) / TakemiZtr)**1.25
     z_Temp(k+1) = z_TakemiTheta(k+1) * (z_Press(k+1) / 100000.0d0)**(GasRDry / CpDry)
     z_LLhumidity(k+1) = za_MolFr(k+1,1) * z_Press(k+1) / SvapPress(6,z_Temp(k+1))

     !!---ؤǺꤷ³м٤ 100 % Ķǽ---!!
     !!--Takemi Ǥϰۤ 100 % ĶΥƥåפͤˤƤ???--!!
 !!--MQ16   99 % ȤͤФ, ۤ 100 %ˤʤäƤޤΤ MQ18 MQ14--!!
     !!--------- 100 % Ķľͤδ֤äͤƤ-----------!!

         if (z_LLhumidity(k+1).gt.1) then
            z_LLhumidity(k+1) = z_LLhumidity(k)
!        if (z_LLhumidity(k+1).gt.0.99) then      !MQ16 
!           z_LLhumidity(k+1) = 0.94511507230d0 !MQ16 

        end if

!!  1.5 km , ή̰ʲ (L < k < T) ξ

   else if (k.le.T.and.k.gt.L) then

     z_TakemiRH(L) = z_LLhumidity(L) ! if ʸν k  L+1 Ϥޤ뤬
                                     !z_TakemiRH(L) ¸ߤʤͤ
     z_Press(k) = &
         & z_Press(k-1)-(Grav*z_Press(k-1)*DelZ) &
         & /((GasRUniv/ &
         & (MolWtMeanDry + (MolWtMeanWet - MolWtMeanDry) &
         & *SvapPress(6,z_Temp(k-1)) &
         & *z_TakemiRH(k-1)/z_Press(k-1))) &
         & *z_Temp(k-1))

     z_TakemiTheta(k) = Theta_0 + (Theta_tr - Theta_0)*(s_Z(k) / TakemiZtr)**1.25
     z_Temp(k) = z_TakemiTheta(k) * (z_Press(k) / 100000.0d0)**(GasRDry / CpDry)

     za_MolFr(k,1) = SvapPress( 6,z_Temp(k))* z_TakemiRH(k)/z_Press(k)
     MolWtMeanDry = MolWtDry * (1.0d0 - za_MolFr(k,1))
     MolWtMeanWet = MolWtWet(1) * za_MolFr(k,1)

     
!! ή̤ (k > T) ξ

   else if (k.gt.T) then

     z_Press(k) = &
         & z_Press(k-1)-(Grav*z_Press(k-1)*DelZ) &
         & /((GasRUniv/ &
         & (MolWtMeanDry + (MolWtMeanWet - MolWtMeanDry) &
         & *SvapPress(6,z_Temp(k-1)) &
         & *z_TakemiRH(k-1)/z_Press(k-1))) &
         & *z_Temp(k-1))

     z_TakemiTheta(k) = Theta_tr * exp(Grav * (s_Z(k) - TakemiZtr) / (CpDry * z_Temp(T)))
     z_Temp(k) = z_TakemiTheta(k) * (z_Press(k) / 100000.0d0)**(GasRDry / CpDry)

     za_MolFr(k,1) = SvapPress( 6,z_Temp(k))* z_TakemiRH(k)/z_Press(k)
     MolWtMeanDry = MolWtDry * (1.0d0 - za_MolFr(k,1))
     MolWtMeanWet = MolWtWet(1) * za_MolFr(k,1)

   end if

  end do

 end subroutine ECCM_Takemi2007

!!!------------------------------------------------------------------------------!!!
  subroutine HUM_Takemi2007ALL(z_RHall)

!!!------!!!
!!Takemi, 2007 м٤μϹ 1.5 km ʹߤΰŬѤΤǤ,
!!ɽ 1.5 km ޤǤϺǤդΰͤͿ,  (Ѵ)
!!٤Ф˰¾ʤƤϤʤʤ.
!!Ԥ HUM_Takemi2007 , Ԥ ECCM_Takemi2007  LLhumidity ǵƤ.
!!Τ, Υ֥롼ξԤ礷, ٤Ǥм z_RHall .

    implicit none

    real(8),intent(out) :: z_RHall(DimZMin:DimZMax)
!   real(8),intent(in)  :: a_MolFrIn(1:SpcNum)
!   real(8),intent(in)  :: Humidity
    real(8) :: a_MolFrIn(1:SpcNum)
    real(8) :: Humidit
    real(8) :: z_Tem(DimZMin:DimZMax)
    real(8) :: z_Pre(DimZMin:DimZMax)
    real(8) :: z_MolMea(DimZMin:DimZMax)
    real(8) :: za_MolF(DimZMin:DimZMax)
    real(8) :: ZTR
    real(8) :: z_humidity1(DimZMin:DimZMax)
    real(8) :: z_humidity2(DimZMin:DimZMax)
    integer :: k, T, L

    call ECCM_Takemi2007(a_MolFrIn, Humidit, z_Tem, z_Pre, z_MolMea, za_MolF, z_humidity1)
    call HUM_Takemi2007(z_humidity2, ZTR, T, L)
!    call HUM_Takemi2007_TDRY(z_humidity2, ZTR, T, L)
!    call HUM_Takemi2007_MDRY(z_humidity2, ZTR, T, L)

    do k = RegZMin+1, DimZMax

      if (k.le.L) then
        z_RHall(k) = z_humidity1(k)

      else if (k.gt.L) then
        z_RHall(k) = z_humidity2(k)

      end if
     end do

   end subroutine HUM_Takemi2007ALL
!!!------------------------------------------------------------------------------!!!
!!!------------------------------------------------------------------------------!!!
  subroutine ECCM_MolFr( a_MolFrIni, Humidity, z_Temp, z_Press, za_MolFr )
    !
    ! Ϳ줿٤Ф, ǮŪ˾徺˼¸
    ! Υץե
    !

    
    !ۤηػ
    implicit none
    
    real(8), intent(in) :: a_MolFrIni(1:SpcNum)
    real(8), intent(in) :: Humidity
    real(8), intent(in) :: z_Temp(DimZMin:DimZMax)
    real(8), intent(in) :: z_Press(DimZMin:DimZMax)
    real(8), intent(out):: za_MolFr(DimZMin:DimZMax, 1:SpcNum)
    
    real(8)             :: DelMolFr
    real(8)             :: Ob_altitude(1:88)       !¬ǡδֳ
    real(8)             :: Ob_HumZ(1:88)               !м٤δ¬(BasicZ )
    real(8)             :: z_HumZ(DimZMin:DimZMax)
    integer             :: k, s

    z_HumZ = 0.0d0

!   call HUM(z_HumZ, Ob_altitude, Ob_HumZ)
    call HUM_Takemi2007ALL(z_HumZ)
    

    !-----------------------------------------------------------
    ! ν
    !-----------------------------------------------------------
    do s = 1, SpcNum
      za_MolFr(:,s) = a_MolFrIni(s) 
    end do

    !-----------------------------------------------------------
    ! ǮΨ dT/dz η׻. 
    !-----------------------------------------------------------
!    do k = RegZMin, DimZMax   ! ǥե
    do k = RegZMin+1, DimZMax

      za_MolFr(k,:) = za_MolFr(k-1,:)
      
      !------------------------------------------------------------
      !NH4SH ʳβؼʿվ
      !------------------------------------------------------------
      do s = 1, CondNum

        !
        !ΥƥåפǤΥĶ뤳ȤϤʤ
!       za_MolFr(k,IdxCG(s)) =                                  &
        za_MolFr(k,1) =                                         &
          & min(                                                &
!         &       za_MolFr(k-1,IdxCG(s)),                       &
          &       za_MolFr(k-1,1),                              &
          &       SvapPress(6, z_Temp(k) )                      &
!         &       SvapPress( SpcWetID(IdxCC(s)), z_Temp(k) )    &
!         &        * Humidity / z_Press(k)                      &
          &        * (z_HumZ(k)/100) / z_Press(k)               &!м٤δ¬ͤ
          &      )        
      end do

      !------------------------------------------------------------
      !NH4SH ʿվ
      !------------------------------------------------------------
      if ( IdxNH3 /= 0 ) then 
        
        !Ѳ. 
        !Ȥꤢ NH4SH Ф˰ 1.0 Ȥ(ȴ...).
        DelMolFr =                                            &
          & max (                                             &
          &    DelMolFrNH4SH(                                 &
          &      z_Temp(k), z_Press(k),                       &
          &      za_MolFr(k,IdxNH3), za_MolFr(k,IdxH2S), Humidity   &
          &     ),                                            &
          &    0.0d0                                          &
          &  )
        
        za_MolFr(k,IdxNH3) = za_MolFr(k,IdxNH3) - DelMolFr 
        za_MolFr(k,IdxH2S) = za_MolFr(k,IdxH2S) - DelMolFr
      end if
      
    end do
  end subroutine ECCM_MolFr



  subroutine ECCM_DTempDZ( Temp, Press, MolFr, DTempDZ )
    
    !ۤηػ
    implicit none
    
    !ѿ
    real(8), intent(in) :: Temp
    real(8), intent(in) :: Press
!    real(8), intent(inout) :: MolFr(0:SpcNum)    !ʬΨ
    real(8), intent(inout) :: MolFr(1:SpcNum)    !ʬΨ
    real(8), intent(out):: DTempDZ
    real(8)             :: MolFrOrig(1:SpcNum) 
    real(8)             :: ReactHeat
    real(8)             :: Heat(SpcNum)
    real(8)             :: DelMolFr
    real(8)             :: SatPress
    real(8)             :: VapPress
    real(8)             :: Humidity
    real(8)             :: A, B
    integer             :: s

    !
    DTempDZ      = 0.0d0
    ReactHeat    = 0.0d0
    Heat         = 0.0d0
    DelMolFr     = 0.0d0
    SatPress     = 0.0d0
    VapPress     = 0.0d0
    MolFrOrig    = MolFr

    !------------------------------------------------------------
    !NH4SH ʳβؼʿվ
    !------------------------------------------------------------
    do s = 1, CondNum      
      
      !˰¾
      SatPress = SvapPress( SpcWetID(IdxCC(s)), Temp )
      
      !Ǯ. 
      Heat(IdxCG(s)) = LatentHeatPerMol( SpcWetID(IdxCC(s)), Temp )
      
      !ΥʬΨѤƸߤξ׻
      VapPress = MolFr(IdxCG(s)) * Press

      !˰¾ŷ̵ͭ
      if ( VapPress < SatPress ) then         
        !ŷ뤷ƤʤΤǮʤ.
        Heat(IdxCG(s)) = 0.0d0                  
      else      
       !˰¾ȰϤ鸽ߤΥ׻
        MolFr(IdxCG(s)) = max(SatPress / Press, 1.0d-16)        
      end if
    end do
    
    !------------------------------------------------------------
    !NH4SH ʿվ
    !------------------------------------------------------------
    if ( IdxNH3 /= 0 ) then 
      
      Humidity = 1.0d0
      DelMolFr =                                            &
        & max (                                             &
        &    DelMolFrNH4SH(                                 &
        &         Temp, Press, MolFr(IdxNH3), MolFr(IdxH2S),&
        &         Humidity                                  &
        &      ),                                           &
        &    0.0d0                                          &
        &  )
      MolFr(IdxNH3) = MolFr(IdxNH3) - DelMolFr
      MolFr(IdxH2S) = MolFr(IdxH2S) - DelMolFr

      ReactHeat = ReactHeatNH4SHPerMol * DelMolFr
    end if
    
    !------------------------------------------------------------
    !ٸۤ׻
    !------------------------------------------------------------
    !.  Temp(i) ɾ
    A = dot_product( Heat(1:SpcNum), MolFrOrig(1:SpcNum)) &
!    A = dot_product( Heat(1:SpcNum), MolFr(1:SpcNum)) &
      & / ( GasRUniv * Temp )
    B = dot_product(( Heat(1:SpcNum) ** 2.0d0), MolFrOrig(1:SpcNum)) &
!    B = dot_product(( Heat(1:SpcNum) ** 2.0d0), MolFr(1:SpcNum)) &
      & / ( CpDryMol * GasRUniv * ( Temp ** 2.0d0 ) )

    !ǮٸΨ
    DTempDZ = - Grav * MolWtDry * (1.0d0 + A) / (CpDryMol * (1.0d0 + B))  &
      &       + ReactHeat / (CpDryMol * DelZ)
   
  end subroutine ECCM_DTempDZ



  subroutine ECCM_Stab( xz_PotTemp, xz_Exner, xza_MixRt )
!    &                   xz_Stab, xz_StabTemp, xz_StabMolWt )

    use gridset,  only: DimXMin,       &!  X β
      &                 DimXMax,       &!  X ξ 
      &                 DimZMin,       &!  Z β
      &                 DimZMax,       &!  Z ξ 
      &                 SpcNum          !
    use basicset,only:  MolWtDry,      &!
      &                 MolWtWet,      &!
      &                 CpDry,         &!
      &                 Grav,          &!
      &                 xz_ExnerBasicZ,   &!
      &                 xz_PotTempBasicZ, &! 
      &                 xz_EffMolWtBasicZ, &!
      &                 xza_MixRtBasicZ
    use average, only:  xz_avr_xr
    use differentiate_center2, only: xr_dz_xz
    
    implicit none

    real(8), intent(in)  :: xz_PotTemp(DimXMin:DimXMax,DimZMin:DimZMax)
    real(8), intent(in)  :: xz_Exner(DimXMin:DimXMax,  DimZMin:DimZMax)
    real(8), intent(in)  :: xza_MixRt(DimXMin:DimXMax, DimZMin:DimZMax, SpcNum)
!    real(8), intent(out) :: xz_Stab(DimXMin:DimXMax,   DimZMin:DimZMax)
!    real(8), intent(out) :: xz_StabTemp(DimXMin:DimXMax, DimZMin:DimZMax)
!    real(8), intent(out) :: xz_StabMolWt(DimXMin:DimXMax, DimZMin:DimZMax)

    real(8)    :: xz_Stab(DimXMin:DimXMax,   DimZMin:DimZMax)
    real(8)    :: xz_StabTemp(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8)    :: xz_StabMolWt(DimXMin:DimXMax, DimZMin:DimZMax)

    real(8)    :: xza_MolFrAll(DimXMin:DimXMax,DimZMin:DimZMax,SpcNum)
    real(8)    :: xz_TempAll(DimXMin:DimXMax,  DimZMin:DimZMax)
    real(8)    :: xz_MolWtWet(DimXMin:DimXMax, DimZMin:DimZMax)
    integer    :: i, k, s

    xz_TempAll = (xz_PotTemp + xz_PotTempBasicZ) * (xz_Exner + xz_ExnerBasicZ)
    do s = 1, SpcNum
      xza_MolFrAll(:,:,s) =                             &
        &   (xza_MixRt(:,:,s) + xza_MixRtBasicZ(:,:,s)) &
        &   * MolWtDry / MolWtWet(s) 
    end do
    
    do k = DimZMin, DimZMax
      do i = DimXMin, DimXMax
        xz_MolWtWet(i,k) = dot_product( MolWtWet(1:GasNum), xza_MolFrAll(i,k,1:GasNum) )
      end do
    end do
    
    xz_StabTemp =                                           &
      &         Grav / xz_TempAll                           &
      &           * (   xz_avr_xr( xr_dz_xz( xz_TempAll ) ) &
      &               + Grav * xz_EffMolWtBasicZ / CpDry ) 
    xz_StabMolWt =                                          &
      &       - Grav * xz_avr_xr( xr_dz_xz( xz_MolWtWet ) ) &
      &         / ( MolWtDry * xz_EffMolWtBasicZ )   
    xz_Stab = xz_StabTemp + xz_StabMolWt
!    xz_Stab =                                               &
!      &         Grav / xz_TempAll                           &
!      &           * ( xz_avr_xr( xr_dz_xz( xz_TempAll ) )   &
!      &               + Grav * xz_EffMolWtBasicZ / CpDry )  &
!      &       - Grav * xz_avr_xr( xr_dz_xz( xz_MolWtWet ) ) &
!      &         / ( MolWtDry * xz_EffMolWtBasicZ )   

    call StoreStabTemp( xz_StabTemp ) 
    call StoreStabMolWt( xz_StabMolWt ) 

    where (xz_Stab < 1.0d-7) 
      xz_Stab = 1.0d-7
    end where

  end subroutine ECCM_Stab
  
end module ECCM
